<template>
  <div class="relative w-full max-w-full px-4 py-0 mx-auto my-0 ml-0">
    <div class="overflow-hidden pt-20 py-4 px-0 pb-20 min-h-[calc(50vh-72px)]">
      <div>
        <div class="max-w-full px-4 py-0 mx-auto my-0 w-ful">
          <div
            class="p-0 w-[540px] max-w-full my-0 mx-auto rounded-[40px] relative"
          >
            <div
              class="relative flex flex-wrap items-center justify-start mb-6"
            >
              <h2
                class="text-2xl w-auto m-0 font-bold text-[var(--title-font-color)]"
              >
                {{ $t("joinnow") }}
              </h2>
            </div>
            <div>
              <el-form
                ref="formRef"
                label-position="top"
                :rules="formRules"
                :model="formModel"
                :validate-on-rule-change="false"
              >
                <el-form-item
                  :class="{ required: rules.Username.required }"
                  :label="$t('username')"
                  prop="Username"
                >
                  <el-input
                    v-model="formModel.Username"
                    :placeholder="$t('username')"
                  />
                </el-form-item>
                <el-form-item
                  :class="{ required: rules.Password.required }"
                  :label="$t('password')"
                  prop="Password"
                >
                  <el-input
                    v-model="formModel.Password"
                    type="password"
                    :placeholder="$t('password')"
                  >
                  </el-input>
                </el-form-item>
                <el-form-item
                  :class="{ required: rules.ConfirmPassword.required }"
                  :label="$t('confirm_password')"
                  prop="ConfirmPassword"
                  show-password
                >
                  <el-input
                    v-model="formModel.ConfirmPassword"
                    type="password"
                    :placeholder="$t('confirm_password')"
                  >
                  </el-input>
                </el-form-item>
                <el-form-item
                  :class="{ required: rules.Currency.required }"
                  :label="$t('currency')"
                  prop="Currency"
                >
                  <el-select
                    v-model="formModel.Currency"
                    style="width: 100%"
                    :placeholder="$t('select_currency')"
                    :disabled="currencies.length <= 0"
                  >
                    <el-option
                      v-for="currency in currencies"
                      :key="currency"
                      :value="String(currency.Currency)"
                    >
                      <div class="flex justify-between w-full">
                        <div class="flex items-center">
                          <div>
                            {{ currency.Currency }}
                          </div>
                        </div>
                      </div>
                    </el-option>
                  </el-select>
                </el-form-item>
                <template v-for="property in availableProperties" :key="property.PropertyName">
                <theme-common-otp-field
                  v-if="property.PropertyName === 'Phone'"
                  v-model="formModel"
                  :label="property.PropertyNameForDisplay"
                  :phone-property="property.PropertyName"
                  :is-required="rules[property.PropertyName].required"
                  :loading="isGettingOtpCode"
                  :next-request-in-seconds="nextRequestOtpInSeconds"
                  @get-code="onGetVerificationCode"
                >
                  <template #phone>
                    <el-form-item
                      :label="property.PropertyNameForDisplay"
                      :prop="property.PropertyName"
                      :class="{ required: rules[property.PropertyName].required }"
                    >
                      <div class="flex flex-1 gap-2 w-full">
                        <el-input
                          v-model="formModel[property.PropertyName]"
                          :placeholder="property.PropertyName"
                          :formatter="(value: string) => value" 
                        :parser="(value: string) => value.replace(/\D+/g, '')"
                        >
                          <template #suffix>
                            <el-tooltip
                              class="box-item"
                              effect="dark"
                              :content="
                                $t(
                                  'valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes'
                                )
                              "
                              placement="bottom"
                            >
                              <el-icon
                                class="el-input__icon"
                                color="var(--primary)"
                              >
                                <info-filled />
                              </el-icon>
                            </el-tooltip>
                          </template>
                        </el-input>
                      </div>
                    </el-form-item>
                  </template>
                </theme-common-otp-field>
                <el-form-item
                  v-else
                  :label="property.PropertyNameForDisplay"
                  :prop="property.PropertyName"
                  :class="{ required: rules[property.PropertyName].required }"
                >
                  <el-select
                    v-if="property.PropertyName === 'Bank'"
                    v-model="formModel.Bank"
                    style="width: 100%"
                    :placeholder="$t('select_bank')"
                    :disabled="bankOptions.length <= 0"
                  >
                    <el-option
                      v-for="bank in bankOptions"
                      :key="bank.Id"
                      :label="bank.BankName"
                      :value="String(bank.Id)"
                    >
                      <div class="flex justify-between w-full">
                        <div class="flex items-center">
                          <div>
                            {{ bank.BankName }}
                          </div>
                        </div>
                      </div>
                    </el-option>
                  </el-select>
                  <div v-else-if="property.PropertyName === 'Gender'">
                    <el-radio v-model="formModel.Gender" label="male">{{
                      $t("male")
                    }}</el-radio>
                    <el-radio v-model="formModel.Gender" label="female">{{
                      $t("female")
                    }}</el-radio>
                  </div>
                  <el-date-picker
                    v-else-if="property.PropertyName === 'DateOfBirth'"
                    v-model="formModel.DateOfBirth"
                    type="date"
                    value-format="YYYY-MM-DD"
                  />
                  <div v-else-if="property.PropertyName === 'Mobile'" class="flex flex-1 gap-2 w-full">
                    <el-input 
                    v-model="formModel[property.PropertyName]" 
                    :placeholder="$t('mobile')"
                    :formatter="(value: string) => value" 
                    :parser="(value: string) => value.replace(/\D+/g, '')"></el-input>
                  </div>
                  <el-input
                    v-else-if="property.PropertyName === 'Referral'"
                    v-model="formModel[property.PropertyName]"
                    :disabled="referralQuery.length"
                    :placeholder="$t('referral')"
                  ></el-input>
                  <el-input v-else-if="property.PropertyName === 'BankAccountName'"
                    :placeholder="property.PropertyNameForDisplay"
                    :disabled="formModel.Bank === '0' || formModel.Bank === ''" v-model="formModel[property.PropertyName]">
                  </el-input>
                  <el-input v-else-if="property.PropertyName === 'BankAccountNumber'"
                    :placeholder="property.PropertyNameForDisplay"
                    :disabled="formModel.Bank === '0' || formModel.Bank === ''" v-model="formModel[property.PropertyName]" 
                    :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')">
                  </el-input>
                  <el-input
                    v-else
                    v-model="formModel[property.PropertyName]"
                    :placeholder="property.PropertyNameForDisplay"
                  ></el-input>
                </el-form-item>
                </template>
                <el-form-item
                  v-if="cashAgentQuery.length"
                  :label="$t('agent_name')"
                  prop="AgentName"
                >
                  <el-input
                    v-model="formModel.AgentName"
                    :class="{
                      'pointer-events-none opacity-80': cashAgentQuery.length,
                    }"
                  />
                </el-form-item>
                <div class="btn-click-captcha-to-verify">
                  <el-form-item
                    v-if="!registerCaptcha.IsHidden"
                    prop="Captcha"
                    :show-message="true"
                  >
                    <div id="captcha-button">
                      <div id="captcha-pop-up-verify" class="w-full">
                        <template
                          v-if="
                            !captchaErrorMsg.length &&
                            formModel.Captcha.length == 5 &&
                            !isDialogVisible
                          "
                        >
                          <div class="relative w-[18px] h-[18px]">
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                                )
                              "
                              alt="verify icon success"
                              loading="lazy"
                            />
                          </div>
                          <span class="whitespace-nowrap text-[#18a452]">{{
                            $t("successful_verification")
                          }}</span>
                        </template>
                        <template v-else>
                          <div
                            class="flex items-center justify-start w-full gap-1"
                            @click="isDialogVisible = true"
                          >
                            <div class="relative w-[18px] h-[18px]">
                              <img
                                :src="
                                  getAssetImage(
                                    'assets/theme/light_flexible_1/desktop/images/verify-icon.png'
                                  )
                                "
                                alt="verify icon"
                                loading="lazy"
                              />
                            </div>
                            <span class="text-[var(--title-font-color)]">{{
                              $t("click_to_verify")
                            }}</span>
                          </div>
                        </template>
                      </div>
                    </div>
                  </el-form-item>
                </div>
                <template class="flex justify-center">
                  <div class="mt-5">
                    <el-button
                      type="primary"
                      round
                      @click="onRegister(formRef)"
                      :loading="isLoading"
                      >{{ $t("joinnow") }}</el-button
                    >
                  </div>
                </template>
                <p class="w-full mt-6 text-base text-[#707585] text-center">
                  {{ $t("already_have_an_account") }}?
                  <nuxt-link
                    class="text-[var(--accent-color)] relative ml-[10px]"
                    to="/login"
                    >{{ $t("capital_login") }}</nuxt-link
                  >
                </p>
              </el-form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="captcha-dialog-container">
    <el-dialog
      v-model="isDialogVisible"
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      width="320px"
      @open="formModel.Captcha = ''"
      @close="formRef?.validateField('Captcha')"
    >
      <utils-client-captcha
        v-if="!registerCaptcha.IsHidden"
        v-model:captcha="formModel.Captcha"
        v-model:dialogVisible="isDialogVisible"
        :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import useRegister from "@/composables/useRegister";
import { registerCaptcha } from "@/composables/captcha/useCaptcha";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  name: "Register",
  setup() {
    const {
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      isLoading,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      availableProperties,
      referralQuery,
      bankOptions,
      cashAgentQuery,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    const { getAssetImage } = commonHelper;
    const isDialogVisible = ref(false);
    return {
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      isLoading,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      availableProperties,
      referralQuery,
      bankOptions,
      cashAgentQuery,
      registerCaptcha,
      getAssetImage,
      isDialogVisible,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    };
  },
});
</script>

<style scoped>
:deep(.otp-field > .cursor-pointer) {
  background-color: var(--background2);
}
:deep(.otp-field > .el-input > .el-input__wrapper > .el-input__suffix) {
  right: 15px;
}
:deep(.otp-field > .el-button) {
  width: 100px;
}
:deep(.el-form-item.is-error .el-form-item__content) {
  flex-direction: column;
  align-items: flex-end;
}
:deep(.el-input.is-disabled .el-input__inner) {
  --el-disabled-bg-color: var(--background-body);
  --el-disabled-text-color: var(--title-font-color);
  -webkit-text-fill-color: var(--background-body);
  box-shadow: var(--box-shadow-inset) !important;
  opacity: 1;
}
:deep(.el-input__inner) {
  height: 40px;
  width: 100%;
  padding: 8px 16px;
  font-family: Roboto, sans-serif;
  font-size: 14px;
  font-weight: 400;
  line-height: 20px;
  color: var(--title-font-color);
  background: var(--background-body);
  border: 1px solid transparent;
  box-shadow: var(--box-shadow-inset);
  border-radius: 8px;
  box-sizing: border-box;
}
:deep(button.el-button) {
  background-color: var(--button-bg) !important;
  color: #707585 !important;
  opacity: unset !important;
  box-shadow: var(--box-shadow);
  display: inline-flex;
  align-items: center;
  justify-content: center;
  height: 40px;
  font-size: 14px;
  box-sizing: border-box;
  text-align: center;
  user-select: none;
  padding: 0 20px;
  white-space: nowrap;
  overflow: hidden;
  font-weight: 600;
  text-decoration: none;
  transition: all 0.5s;
  border-radius: 6px;
  border: none;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4 uppercase;
}
.common-layout #captcha-button {
  height: 40px;
  width: 100%;
  padding: 8px 16px;
  font-family: Roboto, sans-serif;
  font-size: 14px;
  font-weight: 400;
  line-height: 20px;
  color: var(--title-font-color);
  background: var(--background-body);
  border: 1px solid transparent;
  box-shadow: var(--box-shadow-inset);
  border-radius: 8px;
  box-sizing: border-box;
}
.common-layout #captcha-pop-up-verify {
  justify-content: start;
}
.common-layout .captcha-dialog-container {
  --captcha-dialog-border-top-color: var(--primary-fallback);
  --captcha-button-color: var(--primary-fallback);
  --captcha-loading-color: var(--primary-fallback);
  --captcha-submit-button-color: var(--primary-fallback);
  --captcha-submit-button-text-color: #fff;
}
</style>
